diff -Naur openssl-1.0.0q.orig/crypto/asn1/a_d2i_fp.c openssl-1.0.0q/crypto/asn1/a_d2i_fp.c
--- openssl-1.0.0q.orig/crypto/asn1/a_d2i_fp.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/asn1/a_d2i_fp.c	2017-04-25 16:23:39.729526515 +0200
@@ -56,7 +56,9 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include <limits.h>
 #include "cryptlib.h"
 #include <openssl/buffer.h>
@@ -84,6 +86,7 @@
         }
 #endif
 
+#ifndef OPERA_SMALL_VERSION
 void *ASN1_d2i_bio(void *(*xnew)(void), d2i_of_void *d2i, BIO *in, void **x)
 	{
 	BUF_MEM *b = NULL;
@@ -100,9 +103,10 @@
 	if (b != NULL) BUF_MEM_free(b);
 	return(ret);
 	}
-
+#endif
 #endif
 
+#ifndef OPERA_SMALL_VERSION
 void *ASN1_item_d2i_bio(const ASN1_ITEM *it, BIO *in, void *x)
 	{
 	BUF_MEM *b = NULL;
@@ -119,6 +123,7 @@
 	if (b != NULL) BUF_MEM_free(b);
 	return(ret);
 	}
+#endif
 
 #ifndef OPENSSL_NO_FP_API
 void *ASN1_item_d2i_fp(const ASN1_ITEM *it, FILE *in, void *x)
diff -Naur openssl-1.0.0q.orig/crypto/asn1/a_digest.c openssl-1.0.0q/crypto/asn1/a_digest.c
--- openssl-1.0.0q.orig/crypto/asn1/a_digest.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/asn1/a_digest.c	2017-04-25 16:23:39.731528166 +0200
@@ -56,13 +56,17 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
 #include <time.h>
+#endif /* !OPERA_SMALL_VERSION */
 
-#include "cryptlib.h"
+#include <openssl/cryptlib.h>
 
 #ifndef NO_SYS_TYPES_H
+#ifndef OPERA_SMALL_VERSION
 # include <sys/types.h>
+#endif /* !OPERA_SMALL_VERSION */
 #endif
 
 #include <openssl/err.h>
@@ -72,6 +76,7 @@
 
 #ifndef NO_ASN1_OLD
 
+#ifndef OPERA_SMALL_VERSION
 int ASN1_digest(i2d_of_void *i2d, const EVP_MD *type, char *data,
 		unsigned char *md, unsigned int *len)
 	{
@@ -91,7 +96,7 @@
 	OPENSSL_free(str);
 	return(1);
 	}
-
+#endif
 #endif
 
 
@@ -101,7 +106,7 @@
 	int i;
 	unsigned char *str = NULL;
 
-	i=ASN1_item_i2d(asn,&str, it);
+	i=ASN1_item_i2d((ASN1_VALUE *) asn,&str, it);
 	if (!str) return(0);
 
 	EVP_Digest(str, i, md, len, type, NULL);
diff -Naur openssl-1.0.0q.orig/crypto/asn1/a_dup.c openssl-1.0.0q/crypto/asn1/a_dup.c
--- openssl-1.0.0q.orig/crypto/asn1/a_dup.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/asn1/a_dup.c	2017-04-25 16:23:39.733529817 +0200
@@ -56,8 +56,10 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 #include <openssl/asn1.h>
 
 #ifndef NO_OLD_ASN1
@@ -72,13 +74,13 @@
 	if (x == NULL) return(NULL);
 
 	i=i2d(x,NULL);
-	b=OPENSSL_malloc(i+10);
+	b=(unsigned char *) OPENSSL_malloc(i+10);
 	if (b == NULL)
 		{ ASN1err(ASN1_F_ASN1_DUP,ERR_R_MALLOC_FAILURE); return(NULL); }
 	p= b;
 	i=i2d(x,&p);
 	p2= b;
-	ret=d2i(NULL,&p2,i);
+	ret=(char*) d2i(NULL,&p2,i);
 	OPENSSL_free(b);
 	return(ret);
 	}
@@ -99,7 +101,7 @@
 
 	if (x == NULL) return(NULL);
 
-	i=ASN1_item_i2d(x,&b,it);
+	i=ASN1_item_i2d((ASN1_VALUE *) x,&b,it);
 	if (b == NULL)
 		{ ASN1err(ASN1_F_ASN1_ITEM_DUP,ERR_R_MALLOC_FAILURE); return(NULL); }
 	p= b;
diff -Naur openssl-1.0.0q.orig/crypto/asn1/a_enum.c openssl-1.0.0q/crypto/asn1/a_enum.c
--- openssl-1.0.0q.orig/crypto/asn1/a_enum.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/asn1/a_enum.c	2017-04-25 16:23:39.735526439 +0200
@@ -56,8 +56,10 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 #include <openssl/asn1.h>
 #include <openssl/bn.h>
 
@@ -66,11 +68,12 @@
  * for comments on encoding see a_int.c
  */
 
+#ifndef OPERA_SMALL_VERSION
 int ASN1_ENUMERATED_set(ASN1_ENUMERATED *a, long v)
 	{
 	int j,k;
 	unsigned int i;
-	unsigned char buf[sizeof(long)+1];
+	unsigned char buf[sizeof(long)+1]; /* ARRAY OK UNUSED 2009-05-25 yngve */
 	long d;
 
 	a->type=V_ASN1_ENUMERATED;
@@ -79,7 +82,7 @@
 		if (a->data != NULL)
 			OPENSSL_free(a->data);
 		if ((a->data=(unsigned char *)OPENSSL_malloc(sizeof(long)+1)) != NULL)
-			memset((char *)a->data,0,sizeof(long)+1);
+			op_memset((char *)a->data,0,sizeof(long)+1);
 		}
 	if (a->data == NULL)
 		{
@@ -93,7 +96,7 @@
 		a->type=V_ASN1_NEG_ENUMERATED;
 		}
 
-	for (i=0; i<sizeof(long); i++)
+	for (i=0; i< (int) sizeof(long); i++)
 		{
 		if (d == 0) break;
 		buf[i]=(int)d&0xff;
@@ -105,6 +108,7 @@
 	a->length=j;
 	return(1);
 	}
+#endif
 
 long ASN1_ENUMERATED_get(ASN1_ENUMERATED *a)
 	{
@@ -135,6 +139,7 @@
 	return(r);
 	}
 
+#ifndef OPERA_SMALL_VERSION
 ASN1_ENUMERATED *BN_to_ASN1_ENUMERATED(BIGNUM *bn, ASN1_ENUMERATED *ai)
 	{
 	ASN1_ENUMERATED *ret;
@@ -180,3 +185,4 @@
 	else if(ai->type == V_ASN1_NEG_ENUMERATED) BN_set_negative(ret,1);
 	return(ret);
 	}
+#endif
diff -Naur openssl-1.0.0q.orig/crypto/asn1/a_gentm.c openssl-1.0.0q/crypto/asn1/a_gentm.c
--- openssl-1.0.0q.orig/crypto/asn1/a_gentm.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/asn1/a_gentm.c	2017-04-25 16:23:39.736525728 +0200
@@ -58,10 +58,12 @@
 
 /* GENERALIZEDTIME implementation, written by Steve Henson. Based on UTCTIME */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
 #include <time.h>
-#include "cryptlib.h"
-#include "o_time.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
+#include <openssl/o_time.h>
 #include <openssl/asn1.h>
 
 #if 0
@@ -71,7 +73,7 @@
 #ifdef CHARSET_EBCDIC
 	/* KLUDGE! We convert to ascii before writing DER */
 	int len;
-	char tmp[24];
+	char tmp[24]; /* ARRAY OK UNUSED 2009-05-25 yngve EBCDIC ONLY */
 	ASN1_STRING tmpstr = *(ASN1_STRING *)a;
 
 	len = tmpstr.length;
@@ -186,12 +188,13 @@
 	return(0);
 	}
 
+#ifndef OPERA_SMALL_VERSION
 int ASN1_GENERALIZEDTIME_set_string(ASN1_GENERALIZEDTIME *s, const char *str)
 	{
 	ASN1_GENERALIZEDTIME t;
 
 	t.type=V_ASN1_GENERALIZEDTIME;
-	t.length=strlen(str);
+	t.length=op_strlen(str);
 	t.data=(unsigned char *)str;
 	if (ASN1_GENERALIZEDTIME_check(&t))
 		{
@@ -207,6 +210,7 @@
 	else
 		return(0);
 	}
+#endif
 
 ASN1_GENERALIZEDTIME *ASN1_GENERALIZEDTIME_set(ASN1_GENERALIZEDTIME *s,
 	     time_t t)
@@ -217,32 +221,44 @@
 ASN1_GENERALIZEDTIME *ASN1_GENERALIZEDTIME_adj(ASN1_GENERALIZEDTIME *s,
 	     time_t t, int offset_day, long offset_sec)
 	{
+	ASN1_GENERALIZEDTIME *alloced = NULL;
+
 	char *p;
 	struct tm *ts;
 	struct tm data;
 	size_t len = 20; 
 
 	if (s == NULL)
-		s=M_ASN1_GENERALIZEDTIME_new();
+		alloced = s=M_ASN1_GENERALIZEDTIME_new();
 	if (s == NULL)
 		return(NULL);
 
 	ts=OPENSSL_gmtime(&t, &data);
 	if (ts == NULL)
+	{
+		if(alloced)
+			M_ASN1_GENERALIZEDTIME_free(alloced);
 		return(NULL);
+	}
 
 	if (offset_day || offset_sec)
 		{ 
 		if (!OPENSSL_gmtime_adj(ts, offset_day, offset_sec))
+			{
+			if(alloced)
+				M_ASN1_GENERALIZEDTIME_free(alloced);
 			return NULL;
+			}
 		}
 
 	p=(char *)s->data;
 	if ((p == NULL) || ((size_t)s->length < len))
 		{
-		p=OPENSSL_malloc(len);
+		p= (char *) OPENSSL_malloc(len);
 		if (p == NULL)
 			{
+			if(alloced)
+				M_ASN1_GENERALIZEDTIME_free(alloced);
 			ASN1err(ASN1_F_ASN1_GENERALIZEDTIME_ADJ,
 				ERR_R_MALLOC_FAILURE);
 			return(NULL);
@@ -254,7 +270,7 @@
 
 	BIO_snprintf(p,len,"%04d%02d%02d%02d%02d%02dZ",ts->tm_year + 1900,
 		     ts->tm_mon+1,ts->tm_mday,ts->tm_hour,ts->tm_min,ts->tm_sec);
-	s->length=strlen(p);
+	s->length=op_strlen(p);
 	s->type=V_ASN1_GENERALIZEDTIME;
 #ifdef CHARSET_EBCDIC_not
 	ebcdic2ascii(s->data, s->data, s->length);
diff -Naur openssl-1.0.0q.orig/crypto/asn1/a_i2d_fp.c openssl-1.0.0q/crypto/asn1/a_i2d_fp.c
--- openssl-1.0.0q.orig/crypto/asn1/a_i2d_fp.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/asn1/a_i2d_fp.c	2017-04-25 16:23:39.738528497 +0200
@@ -56,7 +56,9 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include "cryptlib.h"
 #include <openssl/buffer.h>
 #include <openssl/asn1.h>
diff -Naur openssl-1.0.0q.orig/crypto/asn1/a_int.c openssl-1.0.0q/crypto/asn1/a_int.c
--- openssl-1.0.0q.orig/crypto/asn1/a_int.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/asn1/a_int.c	2017-04-25 16:23:39.740526516 +0200
@@ -56,8 +56,10 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 #include <openssl/asn1.h>
 #include <openssl/bn.h>
 
@@ -150,7 +152,7 @@
 
 	if (pad) *(p++)=pb;
 	if (a->length == 0) *(p++)=0;
-	else if (!neg) memcpy(p,a->data,(unsigned int)a->length);
+	else if (!neg) op_memcpy(p,a->data,(unsigned int)a->length);
 	else {
 		/* Begin at the end of the encoding */
 		n=a->data + a->length - 1;
@@ -246,7 +248,7 @@
 			p++;
 			len--;
 			}
-		memcpy(s,p,(int)len);
+		op_memcpy(s,p,(int)len);
 	}
 
 	if (ret->data != NULL) OPENSSL_free(ret->data);
@@ -267,7 +269,6 @@
  * ASN1 integers: some broken software can encode a positive INTEGER
  * with its MSB set as negative (it doesn't add a padding zero).
  */
-
 ASN1_INTEGER *d2i_ASN1_UINTEGER(ASN1_INTEGER **a, const unsigned char **pp,
 	     long length)
 	{
@@ -315,7 +316,7 @@
 			p++;
 			len--;
 			}
-		memcpy(s,p,(int)len);
+		op_memcpy(s,p,(int)len);
 		p+=len;
 	}
 
@@ -336,7 +337,7 @@
 	{
 	int j,k;
 	unsigned int i;
-	unsigned char buf[sizeof(long)+1];
+	unsigned char buf[sizeof(long)+1]; /* ARRAY OK 2009-05-25 yngve */
 	long d;
 
 	a->type=V_ASN1_INTEGER;
@@ -345,7 +346,7 @@
 		if (a->data != NULL)
 			OPENSSL_free(a->data);
 		if ((a->data=(unsigned char *)OPENSSL_malloc(sizeof(long)+1)) != NULL)
-			memset((char *)a->data,0,sizeof(long)+1);
+			op_memset((char *)a->data,0,sizeof(long)+1);
 		}
 	if (a->data == NULL)
 		{
@@ -359,7 +360,7 @@
 		a->type=V_ASN1_NEG_INTEGER;
 		}
 
-	for (i=0; i<sizeof(long); i++)
+	for (i=0; i < (int)sizeof(long); i++)
 		{
 		if (d == 0) break;
 		buf[i]=(int)d&0xff;
@@ -422,7 +423,7 @@
 	len=((j == 0)?0:((j/8)+1));
 	if (ret->length < len+4)
 		{
-		unsigned char *new_data=OPENSSL_realloc(ret->data, len+4);
+		unsigned char *new_data= (unsigned char *) OPENSSL_realloc(ret->data, len+4);
 		if (!new_data)
 			{
 			ASN1err(ASN1_F_BN_TO_ASN1_INTEGER,ERR_R_MALLOC_FAILURE);
diff -Naur openssl-1.0.0q.orig/crypto/asn1/a_mbstr.c openssl-1.0.0q/crypto/asn1/a_mbstr.c
--- openssl-1.0.0q.orig/crypto/asn1/a_mbstr.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/asn1/a_mbstr.c	2017-04-25 16:23:39.742528447 +0200
@@ -56,9 +56,11 @@
  *
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
 #include <ctype.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 #include <openssl/asn1.h>
 
 static int traverse_string(const unsigned char *p, int len, int inform,
@@ -97,9 +99,11 @@
 	ASN1_STRING *dest;
 	unsigned char *p;
 	int nchar;
-	char strbuf[32];
+#ifndef OPERA_SMALL_VERSION
+	char strbuf[32];	/* ARRAY OK UNUSED 2009-05-25 yngve */
+#endif
 	int (*cpyfunc)(unsigned long,void *) = NULL;
-	if(len == -1) len = strlen((const char *)in);
+	if(len == -1) len = op_strlen((const char *)in);
 	if(!mask) mask = DIRSTRING_TYPE;
 
 	/* First do a string check and work out the number of characters */
@@ -145,15 +149,19 @@
 
 	if((minsize > 0) && (nchar < minsize)) {
 		ASN1err(ASN1_F_ASN1_MBSTRING_NCOPY, ASN1_R_STRING_TOO_SHORT);
+#ifndef OPERA_SMALL_VERSION
 		BIO_snprintf(strbuf, sizeof strbuf, "%ld", minsize);
 		ERR_add_error_data(2, "minsize=", strbuf);
+#endif
 		return -1;
 	}
 
 	if((maxsize > 0) && (nchar > maxsize)) {
 		ASN1err(ASN1_F_ASN1_MBSTRING_NCOPY, ASN1_R_STRING_TOO_LONG);
+#ifndef OPERA_SMALL_VERSION
 		BIO_snprintf(strbuf, sizeof strbuf, "%ld", maxsize);
 		ERR_add_error_data(2, "maxsize=", strbuf);
+#endif
 		return -1;
 	}
 
@@ -231,7 +239,7 @@
 		cpyfunc = cpy_utf8;
 		break;
 	}
-	if(!(p = OPENSSL_malloc(outlen + 1))) {
+	if(!(p = (unsigned char *) OPENSSL_malloc(outlen + 1))) {
 		if(free_out) ASN1_STRING_free(dest);
 		ASN1err(ASN1_F_ASN1_MBSTRING_NCOPY,ERR_R_MALLOC_FAILURE);
 		return -1;
@@ -287,7 +295,7 @@
 static int in_utf8(unsigned long value, void *arg)
 {
 	int *nchar;
-	nchar = arg;
+	nchar = (int *) arg;
 	(*nchar)++;
 	return 1;
 }
@@ -297,7 +305,7 @@
 static int out_utf8(unsigned long value, void *arg)
 {
 	int *outlen;
-	outlen = arg;
+	outlen = (int *) arg;
 	*outlen += UTF8_putc(NULL, -1, value);
 	return 1;
 }
@@ -328,7 +336,7 @@
 static int cpy_asc(unsigned long value, void *arg)
 {
 	unsigned char **p, *q;
-	p = arg;
+	p = (unsigned char **) arg;
 	q = *p;
 	*q = (unsigned char) value;
 	(*p)++;
@@ -340,7 +348,7 @@
 static int cpy_bmp(unsigned long value, void *arg)
 {
 	unsigned char **p, *q;
-	p = arg;
+	p = (unsigned char **) arg;
 	q = *p;
 	*q++ = (unsigned char) ((value >> 8) & 0xff);
 	*q = (unsigned char) (value & 0xff);
@@ -353,7 +361,7 @@
 static int cpy_univ(unsigned long value, void *arg)
 {
 	unsigned char **p, *q;
-	p = arg;
+	p = (unsigned char **) arg;
 	q = *p;
 	*q++ = (unsigned char) ((value >> 24) & 0xff);
 	*q++ = (unsigned char) ((value >> 16) & 0xff);
@@ -369,7 +377,7 @@
 {
 	unsigned char **p;
 	int ret;
-	p = arg;
+	p = (unsigned char **) arg;
 	/* We already know there is enough room so pass 0xff as the length */
 	ret = UTF8_putc(*p, 0xff, value);
 	*p += ret;
@@ -389,12 +397,12 @@
 	if((ch >= 'a') && (ch <= 'z')) return 1;
 	if((ch >= 'A') && (ch <= 'Z')) return 1;
 	if((ch >= '0') && (ch <= '9')) return 1;
-	if ((ch == ' ') || strchr("'()+,-./:=?", ch)) return 1;
+	if ((ch == ' ') || op_strchr("'()+,-./:=?", ch)) return 1;
 #else /*CHARSET_EBCDIC*/
 	if((ch >= os_toascii['a']) && (ch <= os_toascii['z'])) return 1;
 	if((ch >= os_toascii['A']) && (ch <= os_toascii['Z'])) return 1;
 	if((ch >= os_toascii['0']) && (ch <= os_toascii['9'])) return 1;
-	if ((ch == os_toascii[' ']) || strchr("'()+,-./:=?", os_toebcdic[ch])) return 1;
+	if ((ch == os_toascii[' ']) || op_strchr("'()+,-./:=?", os_toebcdic[ch])) return 1;
 #endif /*CHARSET_EBCDIC*/
 	return 0;
 }
diff -Naur openssl-1.0.0q.orig/crypto/asn1/a_object.c openssl-1.0.0q/crypto/asn1/a_object.c
--- openssl-1.0.0q.orig/crypto/asn1/a_object.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/asn1/a_object.c	2017-04-25 16:23:39.744529818 +0200
@@ -56,14 +56,17 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
 #include <limits.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 #include <openssl/buffer.h>
 #include <openssl/asn1.h>
 #include <openssl/objects.h>
 #include <openssl/bn.h>
 
+#if !defined OPERA_SMALL_VERSION || defined OPERA_NEED_TXT2OBJ
 int i2d_ASN1_OBJECT(ASN1_OBJECT *a, unsigned char **pp)
 	{
 	unsigned char *p;
@@ -76,12 +79,13 @@
 
 	p= *pp;
 	ASN1_put_object(&p,0,a->length,V_ASN1_OBJECT,V_ASN1_UNIVERSAL);
-	memcpy(p,a->data,a->length);
+	op_memcpy(p,a->data,a->length);
 	p+=a->length;
 
 	*pp=p;
 	return(objsize);
 	}
+#endif
 
 int a2d_ASN1_OBJECT(unsigned char *out, int olen, const char *buf, int num)
 	{
@@ -95,7 +99,7 @@
 	if (num == 0)
 		return(0);
 	else if (num == -1)
-		num=strlen(buf);
+		num=op_strlen(buf);
 
 	p=buf;
 	c= *(p++);
@@ -182,7 +186,7 @@
 				if (tmp != ftmp)
 					OPENSSL_free(tmp);
 				tmpsize = blsize + 32;
-				tmp = OPENSSL_malloc(tmpsize);
+				tmp = (char *) OPENSSL_malloc(tmpsize);
 				if (!tmp)
 					goto err;
 				}
@@ -242,7 +246,7 @@
 	i=i2t_ASN1_OBJECT(buf,sizeof buf,a);
 	if (i > (int)(sizeof(buf) - 1))
 		{
-		p = OPENSSL_malloc(i + 1);
+		p = (char*) OPENSSL_malloc(i + 1);
 		if (!p)
 			return -1;
 		i2t_ASN1_OBJECT(p,i + 1,a);
@@ -337,7 +341,7 @@
 			{ i=ERR_R_MALLOC_FAILURE; goto err; }
 		ret->flags|=ASN1_OBJECT_FLAG_DYNAMIC_DATA;
 		}
-	memcpy(data,p,length);
+	op_memcpy(data,p,length);
 	/* reattach data to object, after which it remains const */
 	ret->data  =data;
 	ret->length=length;
@@ -396,6 +400,7 @@
 		OPENSSL_free(a);
 	}
 
+#ifndef OPERA_SMALL_VERSION
 ASN1_OBJECT *ASN1_OBJECT_create(int nid, unsigned char *data, int len,
 	     const char *sn, const char *ln)
 	{
@@ -410,6 +415,7 @@
 		ASN1_OBJECT_FLAG_DYNAMIC_DATA;
 	return(OBJ_dup(&o));
 	}
+#endif
 
 IMPLEMENT_STACK_OF(ASN1_OBJECT)
 IMPLEMENT_ASN1_SET_OF(ASN1_OBJECT)
diff -Naur openssl-1.0.0q.orig/crypto/asn1/a_octet.c openssl-1.0.0q/crypto/asn1/a_octet.c
--- openssl-1.0.0q.orig/crypto/asn1/a_octet.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/asn1/a_octet.c	2017-04-25 16:23:39.746530352 +0200
@@ -56,8 +56,10 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 #include <openssl/asn1.h>
 
 ASN1_OCTET_STRING *ASN1_OCTET_STRING_dup(const ASN1_OCTET_STRING *x)
@@ -68,4 +70,3 @@
 
 int ASN1_OCTET_STRING_set(ASN1_OCTET_STRING *x, const unsigned char *d, int len)
 { return M_ASN1_OCTET_STRING_set(x, d, len); }
-
diff -Naur openssl-1.0.0q.orig/crypto/asn1/a_print.c openssl-1.0.0q/crypto/asn1/a_print.c
--- openssl-1.0.0q.orig/crypto/asn1/a_print.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/asn1/a_print.c	2017-04-25 16:23:39.747526847 +0200
@@ -56,8 +56,11 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+
+#include <openssl/cryptlib.h>
 #include <openssl/asn1.h>
 
 int ASN1_PRINTABLE_type(const unsigned char *s, int len)
@@ -87,8 +90,8 @@
 		if (c&0x80)
 			t61=1;
 #else
-		if (!isalnum(c) && (c != ' ') &&
-		    strchr("'()+,-./:=?", c) == NULL)
+		if (!op_isalnum(c) && (c != ' ') &&
+		    op_strchr("'()+,-./:=?", c) == NULL)
 			ia5=1;
 		if (os_toascii[c] & 0x80)
 			t61=1;
@@ -99,6 +102,7 @@
 	return(V_ASN1_PRINTABLESTRING);
 	}
 
+#ifndef OPERA_SMALL_VERSION
 int ASN1_UNIVERSALSTRING_to_string(ASN1_UNIVERSALSTRING *s)
 	{
 	int i;
@@ -125,3 +129,4 @@
 	s->type=ASN1_PRINTABLE_type(s->data,s->length);
 	return(1);
 	}
+#endif
diff -Naur openssl-1.0.0q.orig/crypto/asn1/a_set.c openssl-1.0.0q/crypto/asn1/a_set.c
--- openssl-1.0.0q.orig/crypto/asn1/a_set.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/asn1/a_set.c	2017-04-25 16:23:39.749527101 +0200
@@ -56,8 +56,10 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 #include <openssl/asn1_mac.h>
 
 #ifndef NO_ASN1_OLD
@@ -77,7 +79,7 @@
     const MYBLOB *b2 = (const MYBLOB *)elem2;
     int r;
 
-    r = memcmp(b1->pbData, b2->pbData,
+    r = op_memcmp(b1->pbData, b2->pbData,
 	       b1->cbData < b2->cbData ? b1->cbData : b2->cbData);
     if(r != 0)
 	return r;
@@ -120,7 +122,7 @@
 
         pStart  = p; /* Catch the beg of Setblobs*/
 		/* In this array we will store the SET blobs */
-		rgSetBlob = OPENSSL_malloc(sk_OPENSSL_BLOCK_num(a) * sizeof(MYBLOB));
+		rgSetBlob = (MYBLOB*) OPENSSL_malloc(sk_OPENSSL_BLOCK_num(a) * sizeof(MYBLOB));
 		if (rgSetBlob == NULL)
 			{
 			ASN1err(ASN1_F_I2D_ASN1_SET,ERR_R_MALLOC_FAILURE);
@@ -140,8 +142,8 @@
 
  /* Now we have to sort the blobs. I am using a simple algo.
     *Sort ptrs *Copy to temp-mem *Copy from temp-mem to user-mem*/
-        qsort( rgSetBlob, sk_OPENSSL_BLOCK_num(a), sizeof(MYBLOB), SetBlobCmp);
-		if (!(pTempMem = OPENSSL_malloc(totSize)))
+        op_qsort( rgSetBlob, sk_OPENSSL_BLOCK_num(a), sizeof(MYBLOB), SetBlobCmp);
+		if (!(pTempMem = (unsigned char *) OPENSSL_malloc(totSize)))
 			{
 			ASN1err(ASN1_F_I2D_ASN1_SET,ERR_R_MALLOC_FAILURE);
 			return(0);
@@ -151,12 +153,12 @@
         p = pTempMem;
         for(i=0; i<sk_OPENSSL_BLOCK_num(a); ++i)
 		{
-                memcpy(p, rgSetBlob[i].pbData, rgSetBlob[i].cbData);
+                op_memcpy(p, rgSetBlob[i].pbData, rgSetBlob[i].cbData);
                 p += rgSetBlob[i].cbData;
 		}
 
 /* Copy back to user mem*/
-        memcpy(pStart, pTempMem, totSize);
+        op_memcpy(pStart, pTempMem, totSize);
         OPENSSL_free(pTempMem);
         OPENSSL_free(rgSetBlob);
 
@@ -216,10 +218,12 @@
 		if (M_ASN1_D2I_end_sequence()) break;
 		/* XXX: This was called with 4 arguments, incorrectly, it seems
 		   if ((s=func(NULL,&c.p,c.slen,c.max-c.p)) == NULL) */
-		if ((s=d2i(NULL,&c.p,c.slen)) == NULL)
+		if ((s=(char *) d2i(NULL,&c.p,c.slen)) == NULL)
 			{
 			ASN1err(ASN1_F_D2I_ASN1_SET,ASN1_R_ERROR_PARSING_SET_ELEMENT);
+#ifndef OPERA_SMALL_VERSION
 			asn1_add_error(*pp,(int)(c.p- *pp));
+#endif
 			goto err;
 			}
 		if (!sk_OPENSSL_BLOCK_push(ret,s)) goto err;
diff -Naur openssl-1.0.0q.orig/crypto/asn1/a_sign.c openssl-1.0.0q/crypto/asn1/a_sign.c
--- openssl-1.0.0q.orig/crypto/asn1/a_sign.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/asn1/a_sign.c	2017-04-25 16:23:39.751525680 +0200
@@ -109,13 +109,17 @@
  *
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
 #include <time.h>
+#endif /* !OPERA_SMALL_VERSION */
 
-#include "cryptlib.h"
+#include <openssl/cryptlib.h>
 
 #ifndef NO_SYS_TYPES_H
+#ifndef OPERA_SMALL_VERSION
 # include <sys/types.h>
+#endif /* !OPERA_SMALL_VERSION */
 #endif
 
 #include <openssl/bn.h>
@@ -127,6 +131,7 @@
 
 #ifndef NO_ASN1_OLD
 
+#ifndef OPERA_SMALL_VERSION
 int ASN1_sign(i2d_of_void *i2d, X509_ALGOR *algor1, X509_ALGOR *algor2,
 	      ASN1_BIT_STRING *signature, char *data, EVP_PKEY *pkey,
 	      const EVP_MD *type)
@@ -210,9 +215,11 @@
 		{ OPENSSL_cleanse((char *)buf_out,outll); OPENSSL_free(buf_out); }
 	return(outl);
 	}
+#endif /* !OPERA_SMALL_VERSION */
 
 #endif
 
+#ifdef LIBOPEAY_ASYNCHRONOUS_KEYGENERATION
 int ASN1_item_sign(const ASN1_ITEM *it, X509_ALGOR *algor1, X509_ALGOR *algor2,
 	     ASN1_BIT_STRING *signature, void *asn, EVP_PKEY *pkey,
 	     const EVP_MD *type)
@@ -260,7 +267,7 @@
 		X509_ALGOR_set0(algor2, OBJ_nid2obj(signid), paramtype, NULL);
 
 	EVP_MD_CTX_init(&ctx);
-	inl=ASN1_item_i2d(asn,&buf_in, it);
+	inl=ASN1_item_i2d((ASN1_VALUE *) asn,&buf_in, it);
 	outll=outl=EVP_PKEY_size(pkey);
 	buf_out=(unsigned char *)OPENSSL_malloc((unsigned int)outl);
 	if ((buf_in == NULL) || (buf_out == NULL))
@@ -296,3 +303,4 @@
 		{ OPENSSL_cleanse((char *)buf_out,outll); OPENSSL_free(buf_out); }
 	return(outl);
 	}
+#endif // LIBOPEAY_ASYNCHRONOUS_KEYGENERATION
diff -Naur openssl-1.0.0q.orig/crypto/asn1/a_strex.c openssl-1.0.0q/crypto/asn1/a_strex.c
--- openssl-1.0.0q.orig/crypto/asn1/a_strex.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/asn1/a_strex.c	2017-04-25 16:23:39.753527051 +0200
@@ -56,9 +56,11 @@
  *
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
 #include <string.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 #include <openssl/crypto.h>
 #include <openssl/x509.h>
 #include <openssl/asn1.h>
@@ -88,7 +90,7 @@
 {
 	unsigned char **out = arg;
 	if(!out) return 1;
-	memcpy(*out, buf, len);
+	op_memcpy(*out, buf, len);
 	*out += len;
 	return 1;
 }
@@ -97,16 +99,18 @@
 static int send_bio_chars(void *arg, const void *buf, int len)
 {
 	if(!arg) return 1;
-	if(BIO_write(arg, buf, len) != len) return 0;
+	if(BIO_write((BIO *) arg, buf, len) != len) return 0;
 	return 1;
 }
 
+#ifndef OPENSSL_NO_FP_API
 static int send_fp_chars(void *arg, const void *buf, int len)
 {
 	if(!arg) return 1;
 	if(fwrite(buf, 1, len, arg) != (unsigned int)len) return 0;
 	return 1;
 }
+#endif
 
 typedef int char_io(void *arg, const void *buf, int len);
 
@@ -120,7 +124,7 @@
 static int do_esc_char(unsigned long c, unsigned char flags, char *do_quotes, char_io *io_ch, void *arg)
 {
 	unsigned char chflgs, chtmp;
-	char tmphex[HEX_SIZE(long)+3];
+	char tmphex[HEX_SIZE(long)+3]; /* ARRAY OK 2009-05-25 yngve */
 
 	if(c > 0xffffffffL)
 		return -1;
@@ -149,7 +153,7 @@
 		return 2;
 	}
 	if(chflgs & (ASN1_STRFLGS_ESC_CTRL|ASN1_STRFLGS_ESC_MSB)) {
-		BIO_snprintf(tmphex, 11, "\\%02X", chtmp);
+		BIO_snprintf(tmphex, sizeof tmphex, "\\%02X", chtmp);
 		if(!io_ch(arg, tmphex, 3)) return -1;
 		return 3;
 	}
@@ -177,7 +181,7 @@
 {
 	int i, outlen, len;
 	unsigned char orflags, *p, *q;
-	unsigned long c;
+	unsigned long c=0;
 	p = buf;
 	q = buf + buflen;
 	outlen = 0;
@@ -211,7 +215,7 @@
 		}
 		if (p == q && flags & ASN1_STRFLGS_ESC_2253) orflags = CHARTYPE_LAST_ESC_2253;
 		if(type & BUF_TYPE_CONVUTF8) {
-			unsigned char utfbuf[6];
+			unsigned char utfbuf[6]; /* ARRAY OK 2007-11-07 yngve */
 			int utflen;
 			utflen = UTF8_putc(utfbuf, sizeof utfbuf, c);
 			for(i = 0; i < utflen; i++) {
@@ -237,9 +241,9 @@
 
 static int do_hex_dump(char_io *io_ch, void *arg, unsigned char *buf, int buflen)
 {
-	static const char hexdig[] = "0123456789ABCDEF";
+	const char *const hexdig = "0123456789ABCDEF";
 	unsigned char *p, *q;
-	char hextmp[2];
+	char hextmp[2]; /* ARRAY OK 2009-05-25 yngve */
 	if(arg) {
 		p = buf;
 		q = buf + buflen;
@@ -278,7 +282,7 @@
 	t.type = str->type;
 	t.value.ptr = (char *)str;
 	der_len = i2d_ASN1_TYPE(&t, NULL);
-	der_buf = OPENSSL_malloc(der_len);
+	der_buf = (unsigned char *) OPENSSL_malloc(der_len);
 	if(!der_buf) return -1;
 	p = der_buf;
 	i2d_ASN1_TYPE(&t, &p);
@@ -326,13 +330,15 @@
 	outlen = 0;
 
 
+#ifndef OPERA_SMALL_VERSION
 	if(lflags & ASN1_STRFLGS_SHOW_TYPE) {
 		const char *tagname;
 		tagname = ASN1_tag2str(type);
-		outlen += strlen(tagname);
+		outlen += op_strlen(tagname);
 		if(!io_ch(arg, tagname, outlen) || !io_ch(arg, ":", 1)) return -1; 
 		outlen++;
 	}
+#endif
 
 	/* Decide what to do with type, either dump content or display it */
 
@@ -397,10 +403,10 @@
 	ASN1_OBJECT *fn;
 	ASN1_STRING *val;
 	X509_NAME_ENTRY *ent;
-	char objtmp[80];
+	char objtmp[80]; /* ARRAY OK 2009-05-25 yngve */
 	const char *objbuf;
 	int outlen, len;
-	char *sep_dn, *sep_mv, *sep_eq;
+	const char *sep_dn, *sep_mv, *sep_eq;
 	int sep_dn_len, sep_mv_len, sep_eq_len;
 	if(indent < 0) indent = 0;
 	outlen = indent;
@@ -490,7 +496,7 @@
 					objbuf = "";
 				}
 			}
-			objlen = strlen(objbuf);
+			objlen = op_strlen(objbuf);
 			if(!io_ch(arg, objbuf, objlen)) return -1;
 			if ((objlen < fld_len) && (flags & XN_FLAG_FN_ALIGN)) {
 				if (!do_indent(io_ch, arg, fld_len - objlen)) return -1;
diff -Naur openssl-1.0.0q.orig/crypto/asn1/a_strnid.c openssl-1.0.0q/crypto/asn1/a_strnid.c
--- openssl-1.0.0q.orig/crypto/asn1/a_strnid.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/asn1/a_strnid.c	2017-04-25 16:23:39.849527800 +0200
@@ -56,17 +56,21 @@
  *
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
 #include <ctype.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 #include <openssl/asn1.h>
 #include <openssl/objects.h>
 
 
+#ifndef OPERA_SMALL_VERSION
 static STACK_OF(ASN1_STRING_TABLE) *stable = NULL;
 static void st_free(ASN1_STRING_TABLE *tbl);
 static int sk_table_cmp(const ASN1_STRING_TABLE * const *a,
 			const ASN1_STRING_TABLE * const *b);
+#endif /* !OPERA_SMALL_VERSION */
 
 
 /* This is the global mask for the mbstring functions: this is use to
@@ -74,8 +78,14 @@
  * certain software (e.g. Netscape) has problems with them.
  */
 
+#ifndef _NO_GLOBALS_
 static unsigned long global_mask = B_ASN1_UTF8STRING;
+#else
+static const unsigned long global_mask = 0xFFFFFFFFL;
+#endif // !_NO_GLOBALS_
 
+#ifndef OPERA_SMALL_VERSION
+#ifndef _NO_GLOBALS_
 void ASN1_STRING_set_default_mask(unsigned long mask)
 {
 	global_mask = mask;
@@ -99,21 +109,23 @@
 {
 	unsigned long mask;
 	char *end;
-	if(!strncmp(p, "MASK:", 5)) {
+	if(!op_strncmp(p, "MASK:", 5)) {
 		if(!p[5]) return 0;
-		mask = strtoul(p + 5, &end, 0);
+		mask = op_strtoul(p + 5, &end, 0);
 		if(*end) return 0;
-	} else if(!strcmp(p, "nombstr"))
+	} else if(!op_strcmp(p, "nombstr"))
 			 mask = ~((unsigned long)(B_ASN1_BMPSTRING|B_ASN1_UTF8STRING));
-	else if(!strcmp(p, "pkix"))
+	else if(!op_strcmp(p, "pkix"))
 			mask = ~((unsigned long)B_ASN1_T61STRING);
-	else if(!strcmp(p, "utf8only")) mask = B_ASN1_UTF8STRING;
-	else if(!strcmp(p, "default"))
+	else if(!op_strcmp(p, "utf8only")) mask = B_ASN1_UTF8STRING;
+	else if(!op_strcmp(p, "default"))
 	    mask = 0xFFFFFFFFL;
 	else return 0;
 	ASN1_STRING_set_default_mask(mask);
 	return 1;
 }
+#endif // !_NO_GLOBALS_
+#endif // !OPERA_SMALL_VERSION
 
 /* The following function generates an ASN1_STRING based on limits in a table.
  * Frequently the types and length of an ASN1_STRING are restricted by a 
@@ -179,11 +191,13 @@
 {NID_ms_csp_name,		-1, -1, B_ASN1_BMPSTRING, STABLE_NO_MASK}
 };
 
+#ifndef OPERA_SMALL_VERSION
 static int sk_table_cmp(const ASN1_STRING_TABLE * const *a,
 			const ASN1_STRING_TABLE * const *b)
 {
 	return (*a)->nid - (*b)->nid;
 }
+#endif
 
 DECLARE_OBJ_BSEARCH_CMP_FN(ASN1_STRING_TABLE, ASN1_STRING_TABLE, table);
 
@@ -196,19 +210,26 @@
 
 ASN1_STRING_TABLE *ASN1_STRING_TABLE_get(int nid)
 {
+#ifndef OPERA_SMALL_VERSION
 	int idx;
+#endif // !OPERA_SMALL_VERSION
 	ASN1_STRING_TABLE *ttmp;
 	ASN1_STRING_TABLE fnd;
 	fnd.nid = nid;
 	ttmp = OBJ_bsearch_table(&fnd, tbl_standard, 
 			   sizeof(tbl_standard)/sizeof(ASN1_STRING_TABLE));
 	if(ttmp) return ttmp;
+#ifdef OPERA_SMALL_VERSION
+	return NULL;
+#else
 	if(!stable) return NULL;
 	idx = sk_ASN1_STRING_TABLE_find(stable, &fnd);
 	if(idx < 0) return NULL;
 	return sk_ASN1_STRING_TABLE_value(stable, idx);
+#endif // OPERA_SMALL_VERSION
 }
-	
+
+#ifndef OPERA_SMALL_VERSION
 int ASN1_STRING_TABLE_add(int nid,
 		 long minsize, long maxsize, unsigned long mask,
 				unsigned long flags)
@@ -252,6 +273,7 @@
 {
 	if(tbl->flags & STABLE_FLAGS_MALLOC) OPENSSL_free(tbl);
 }
+#endif // !OPERA_SMALL_VERSION
 
 
 IMPLEMENT_STACK_OF(ASN1_STRING_TABLE)
diff -Naur openssl-1.0.0q.orig/crypto/asn1/a_time.c openssl-1.0.0q/crypto/asn1/a_time.c
--- openssl-1.0.0q.orig/crypto/asn1/a_time.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/asn1/a_time.c	2017-04-25 16:23:39.851526937 +0200
@@ -61,22 +61,27 @@
  * written by Steve Henson.
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
 #include <time.h>
-#include "cryptlib.h"
-#include "o_time.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
+#include <openssl/o_time.h>
 #include <openssl/asn1t.h>
+#include "modules/libopeay/libopeay_arrays.h"
 
 IMPLEMENT_ASN1_MSTRING(ASN1_TIME, B_ASN1_TIME)
 
+#ifndef OPERA_SMALL_VERSION
 IMPLEMENT_ASN1_FUNCTIONS(ASN1_TIME)
+#endif
 
 #if 0
 int i2d_ASN1_TIME(ASN1_TIME *a, unsigned char **pp)
 	{
 #ifdef CHARSET_EBCDIC
 	/* KLUDGE! We convert to ascii before writing DER */
-	char tmp[24];
+	char tmp[24]; /* ARRAY OK UNUSED 2009-05-25 yngve EBCDIC only*/
 	ASN1_STRING tmpstr;
 
 	if(a->type == V_ASN1_UTCTIME || a->type == V_ASN1_GENERALIZEDTIME) {
@@ -134,6 +139,7 @@
 	return 0;
 	}
 
+#ifndef OPERA_SMALL_VERSION
 /* Convert an ASN1_TIME structure to GeneralizedTime */
 ASN1_GENERALIZEDTIME *ASN1_TIME_to_generalizedtime(ASN1_TIME *t, ASN1_GENERALIZEDTIME **out)
 	{
@@ -173,12 +179,13 @@
 
 	return ret;
 	}
+#endif // !OPERA_SMALL_VERSION
 
 int ASN1_TIME_set_string(ASN1_TIME *s, const char *str)
 	{
 	ASN1_TIME t;
 
-	t.length = strlen(str);
+	t.length = op_strlen(str);
 	t.data = (unsigned char *)str;
 	t.flags = 0;
 	
